# 文档

1. 引入
```
1). 这种引入方式，erp中不得行
import HftOssUpload from "hft-oss-upload";
Vue.use(HftOssUpload as any);

2). 按需加载，通用
import OssUpload from "hft-oss-upload";
@Component({
    components: {
      "hft-oss-upload": OssUpload.HftOssUpload
    }
})

<HftOssUpload />

main.ts
引入样式
import "hft-oss-upload/lib/hft-oss-upload.css";
```

2. 参数
```
// 必选参数，上传的地址
@Prop({default: () => ""})action!: string;
// 产品端 必选
@Prop({default: () => ""})projectType!: string;
// 环境区分 1线上 2本地 必传 
@Prop({default: () => 1})envStatus!: number;
// 图片上传类型 必传 
@Prop({default: () => "image/png,image/jpeg,image/gif,image/jpg"})accept!: string;

// 默认外层样式
@Prop({default: () => {}})styleObj!: object;
// 经纪人id
@Prop({default: () => ""})archiveId!: string;
// C端用户id
@Prop({default: () => ""})cUserId!: string;
// 设备类型 1、2分别是安卓 ios ， web 传3吧
@Prop({default: () => 3})deviceType!: number
// 是否开启多选
@Prop({default: () => false})multiple!: boolean;
// 文件最大值单位M
@Prop({default: () => 25})fileMaxSize!: number;
```

3. 回调事件
```
失败回调
@onError=onError
onError(info: {msg: string, code: ErrorCode}): void{}

export enum ErrorCode {
  // 超过尺寸
  outSize = 1,
  // 缺少参数
  lackParams = 2,
  // 超过最大数量
  outLength = 3,
  // 上传失败
  fail = 4,
}



成功回调
@onSuccess=onSuccess
onSuccess(list: Array<ImageUploadResponse>): void{}

export class ImageUploadResponse extends APIResponse{
  // 全地址
  fullUrl: string = "";
  // 文件名称
  @SerializedName("saveName")
  name: string = "";
  // 源文件名字
  oriName: string = "";
  // 前缀
  domain: string = "";
  // 文件大小
  size: number = 0;
}

```
