
// 处理房源相关
export class AboutHouse {
  /**
   *  总楼层大于18层时, 楼层<=6为低层, 楼层7~14为中层, 大于15层为高层
   *  总楼层在8~18时, 楼层<=3为低层, 楼层4~15为中层, 大于16层为高层
   *  总楼层小于8层时, 楼层<=3为低层, 楼层4~5为中层, 大于6层为高层
   * @param allFloor 总楼层
   * @param floor 当前楼层
   */
  dealHouseFloor(allFloor: number, floor: number): string{
    if (!allFloor || !floor) return "";

    let floorStr = "";
    if (allFloor > 18){
      floorStr = floor <= 6 ? "低层" : (floor >= 15 ? "高层" : "中层");
    }

    if (allFloor > 8 && allFloor <= 18){
      floorStr = floor <= 3 ? "低层" : (floor >= 16 ? "高层" : "中层");
    }

    if (allFloor <= 8){
      floorStr = floor <= 3 ? "低层" : (floor >= 6 ? "高层" : "中层");
    }

    return floorStr;
  }


}
