import {eventBus} from "@/common/eventBus";
import {NotifyName} from "@/common/Notify";

function callbackVal<T>(info: T) {}


export class Notification<T> {
  addObserver(name: NotifyName, callback: (info: T) => void = () => {}) {
    eventBus.$on(`NotifyName${name}`, (info: T) => {
      callback(info);
    });
  }
  
  removeObserver(name: NotifyName) {
    eventBus.$off(`NotifyName${name}`);
  }
  
  postNotification(name: NotifyName, info?: T) {
    eventBus.$emit(`NotifyName${name}`, info);
  }
  
  removeObserverAllNotification(names: Array<NotifyName>) {
    for (let name of names) {
      this.removeObserver(name);
    }
  }
}
