import {API, APIRequest} from "./API";
import {RequestMethodEnum, WxRequest} from "@/common/net/WxRequest";


export abstract class GetRequest<T> extends API<T> {
  constructor(request: APIRequest) {
    super(request);
  }

  run(): Promise<T> {
    let headers = this.getHeader();
    if (this.getNeedClientKey()) {
    }
    const requestVal = new WxRequest(this.getApiDomain(), this.getUrl(), headers,
      RequestMethodEnum.GET, this.request, this.getNeedFormData(), this.addPlateToHeader(),
      this.needDealDomain(), this.useRedirect(), this.getAction());
    return requestVal.request()
      .then(res => {
        this.setResponse(this.parse(res));
        return this.setModel();
      })
      .then(() => {
        return this.getResponse()!;
      })
      .catch((err) => {
        this.setFailResponse(err.data || {});
        if (this.isShowFailToast()) {
        }
        return Promise.reject(err);
      });
  }

  protected abstract parse(json: object): T;

  protected abstract setModel(): Promise<void>;
}
