import { ClassArray } from "./ClassArray";


export class Utils {
  public static setObjectNull(o: any) {
    for (let key in o) {
      if (o[key] instanceof Array) {
        o[key] = [];
        continue;
      }

      if (typeof o[key] === "object") {
        Utils.setObjectNull(o[key]);
      }

      o[key] = null;
    }
  }

  public static getProperty<T, K extends keyof T>(o: T, name: K): T[K] {
    return o[name]; // o[name] is of type T[K]
  }

  public static equals(o1:object|null, o2:object|null):boolean;
  public static equals(o1:string|null, o2:string|null):boolean;
  public static equals(o1:number|null, o2:number|null):boolean;
  public static equals(o1:Array<any>|null, o2:Array<any>|null):boolean;
  public static equals(o1:any, o2:any):boolean {
    if(typeof o1 !== typeof o2) {
      return false;
    }

    if (typeof o1 == "string" || typeof o1 == "number" || o1 === null) {
      return o1 === o2;
    }

    if (typeof o1 == "object" && !(o1 instanceof Array)) {
      for (let key in o1) {
        if (o2[key] === undefined) {
          return false;
        }

        if (!Utils.equals(o1[key], o1[key])) {
          return false;
        }
      }

      return true;
    }

    // array
    if (o1 instanceof Array && o2 instanceof Array) {
      if (o1.length != o2.length) {
        return false;
      }

      for (let i = 0; i < o1.length; ++i) {
        if (!Utils.equals(o1[i], o2[i])) {
          return false;
        }
      }

      return true;
    }

    return false;
  }
}

