import {APIRequest, APIResponse} from "@/common/net/API";
import {GetRequest} from "@/common/net/GetRequest";
import {Config} from "@/config/Config";
import {Json} from "@/common/utils/Json";
import {ImageUploadRequest} from "@/net/ImageUpload";


export class GetOSSAuthTokenRequest extends APIRequest{

}

export class GetOSSAuthTokenResponse extends APIResponse{
  // code码
  StatusCode: string = "";
  //从STS服务获取的临时访问凭证。临时访问凭证包括临时访问密钥（AccessKeyId和AccessKeySecret）和安全令牌（SecurityToken）。
  AccessKeyId: string = "";
  //从STS服务获取的临时访问凭证。临时访问凭证包括临时访问密钥（AccessKeyId和AccessKeySecret）和安全令牌（SecurityToken）。
  AccessKeySecret: string = "";
  // 安全令牌
  SecurityToken: string = "";
  // 过期时间
  Expiration: string = "";
}

// 获取oss验证信息
export class GetOSSAuthToken extends GetRequest<GetOSSAuthTokenResponse>{
  // 必传请求服务器地址
  private _action: string = "";
  
  constructor(props: GetOSSAuthTokenRequest = new GetOSSAuthTokenRequest(), action: string) {
    super(props);
    this._action = action;
  }
  
  getApiDomain(): Config {
    return "";
  }
  
  getUrl(): string {
    return "http://fileweb.myfun7.com/fileWeb/getOSSAuthToken";
  }
  
  getAction(): string {
    return this._action;
  }
  
  useRedirect(): boolean {
    return true;
  }
  
  protected parse(json: object): GetOSSAuthTokenResponse {
    return new Json().fromJson(json, GetOSSAuthTokenResponse);
  }
  
  protected setModel(): Promise<void> {
    return Promise.resolve(undefined);
  }
}
