import v from "@/main";

export interface RouterOptionsInterface{
  [key: string] : any,
}

export enum RouteNameEnum {
  // 默认
  default = "default",
  // oss
  oss = "oss"
}

// 路由相关方法
export class RouterUtil {
  // 路由名称
  getRouteName(): RouteNameEnum {
    return (v as any).$route.name;
  }

  // 通过地址获取路由名称(为了兼容第一个， getRouteName以后会慢慢退出历史舞台)
  getRouteNameByHref(): RouteNameEnum {
    for (let name in RouteNameEnum) {
      if (((window as any).location.href as string).indexOf(name) >= 0) {
        return RouteNameEnum[name as RouteNameEnum];
      }
    }

    return RouteNameEnum.default;
  }

  // 合并连接
  assignUrl(url: string, options: RouterOptionsInterface = {}): string {
    for (let k in options) {
      if (url.indexOf("?") !== -1) {
        url += `&${k}=${options[k]}`;
        continue;
      }

      url += `?${k}=${options[k]}`;
    }
    return url;
  }

  // 获取路由参数val
  getRouteQuery<T>(key: string): T {
    let query: any = (v as any).$route.query || {};
    return query[key] || "";
  }
}
