import Vue from 'vue';
import VueRouter from 'vue-router';
import {RouteNameEnum} from "@/router/RouterUtil";
import {ossRouterList} from "@/router/routerList/ossRouterList";

Vue.use(VueRouter)

export interface RouterParametersInter {
  [key: string]: any,
}

export interface RouterConfigInter {
  path: string,
  name: RouteNameEnum,
  component: () => {},
  meta: {
    title: string,
    keepAlive?: boolean,
  },
  parameters: RouterParametersInter
}

export const routes: Array<RouterConfigInter> = [
  ...ossRouterList,
];

const router = new VueRouter({
  routes
});

interface RouterQueryInter {
  clientKey: string;

  [key: string]: any;
}
router.beforeEach((to: any, from, next: Function) => {
  next();
});
export default router
